=== debian/control ===
Source: uclibc
Section: devel
Priority: optional
Maintainer: David Schleef <ds@schleef.org>
Build-Depends: debhelper, kernel-headers | kernel-headers-2.4.10
Standards-Version: 3.5.2

Package: libuclibc-dev
Section: devel
Architecture: any
Depends: ${shlibs:Depends}
Description: A small implementation of the C library
 uClibc is an implementation of the standard C library that is
 much smaller than glibc, which makes it useful for embedded
 systems.

Package: libuclibc0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}
Description: A small implementation of the C library
 uClibc is an implementation of the standard C library that is
 much smaller than glibc, which makes it useful for embedded
 systems.

Package: uclibc-toolchain
Section: devel
Architecture: any
Depends: gcc|c-compiler, binutils, ${shlibs:Depends}
Conflicts: uclibc-gcc
Replaces: uclibc-gcc
Description: A compiler wrapper for uClibc
 This is a small wrapper for gcc, ld, and other toolchain utilities
 to do compilation against uClibc instead of the native libc.
 This package is used for cross compiling.
